Debian Bug report logs - #580308
distcc-pump: Debian patches to distcc shouldn't hardcode python versions

version graph

Package: distcc-pump; Maintainer for distcc-pump is Daniel Hartwig <mandyke@gmail.com>; Source for distcc-pump is src:distcc.

Reported by: Michael Casadevall <mcasadevall@debian.org>

Date: Wed, 5 May 2010 06:06:02 UTC

Severity: grave

Tags: patch

Found in version distcc/3.1-2

Fixed in version distcc/3.1-4.2

Done: Daniel Hartwig <mandyke@gmail.com>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, Carsten Wolff <carsten@wolffcarsten.de>:
Bug#580308; Package distcc-pump. (Wed, 05 May 2010 06:06:05 GMT) Full text and rfc822 format available.

Acknowledgement sent to Michael Casadevall <mcasadevall@debian.org>:
New Bug report received and forwarded. Copy sent to Carsten Wolff <carsten@wolffcarsten.de>. (Wed, 05 May 2010 06:06:05 GMT) Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Michael Casadevall <mcasadevall@debian.org>
To: Debian Bug Tracking System <submit@bugs.debian.org>
Subject: distcc-pump: Debian patches to distcc shouldn't hardcode python versions
Date: Wed, 05 May 2010 02:04:08 -0400
Package: distcc-pump
Version: 3.1-2
Severity: important

The 04_fix_pumps_include_server_path.dpatch included in Debian hardcodes
a python2.5 path in place. This causes the pump server to fail to start
if only python 2.6 is available and python 2.5 isn't installed.

This bug was originally found in Ubuntu, here's the original bugs:
http://bugs..launchpad.net/ubuntu/+source/distcc/+bug/472201
http://bugs..launchpad.net/ubuntu/+source/distcc/+bug/511585

Michael

-- System Information:
Debian Release: squeeze/sid
  APT prefers lucid-updates
  APT policy: (500, 'lucid-updates'), (500, 'lucid-security'), (500, 'lucid')
Architecture: amd64 (x86_64)

Kernel: Linux 2.6.32-21-generic (SMP w/2 CPU cores)
Locale: LANG=en_US.UTF-8, LC_CTYPE=en_US.UTF-8 (charmap=UTF-8)
Shell: /bin/sh linked to /bin/dash

Versions of packages distcc-pump depends on:
ii  distcc          3.1-2                    Simple distributed compiler client
ii  libc6           2.11.1-0ubuntu7          Embedded GNU C Library: Shared lib
ii  python          2.6.5-0ubuntu1launchpad1 An interactive high-level object-o
ii  python-support  1.0.4ubuntu1launchpad2   automated rebuilding support for P

distcc-pump recommends no packages.

distcc-pump suggests no packages.

-- no debconf information




Information forwarded to debian-bugs-dist@lists.debian.org, Carsten Wolff <carsten@wolffcarsten.de>:
Bug#580308; Package distcc-pump. (Mon, 28 Nov 2011 11:42:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Mike Hommey <mh@glandium.org>:
Extra info received and forwarded to list. Copy sent to Carsten Wolff <carsten@wolffcarsten.de>. (Mon, 28 Nov 2011 11:42:09 GMT) Full text and rfc822 format available.

Message #10 received at 580308@bugs.debian.org (full text, mbox):

From: Mike Hommey <mh@glandium.org>
To: 580308@bugs.debian.org
Cc: control@bugs.debian.org
Subject: Re: Bug#580308: distcc-pump: Debian patches to distcc shouldn't hardcode python versions
Date: Mon, 28 Nov 2011 12:38:22 +0100
severity 580308 grave
thanks

On Wed, May 05, 2010 at 02:04:08AM -0400, Michael Casadevall wrote:
> Package: distcc-pump
> Version: 3.1-2
> Severity: important
> 
> The 04_fix_pumps_include_server_path.dpatch included in Debian hardcodes
> a python2.5 path in place. This causes the pump server to fail to start
> if only python 2.6 is available and python 2.5 isn't installed.

This simply makes the package useless for new installs, where python 2.5
is not installed.

Mike




Severity set to 'grave' from 'important' Request was from Mike Hommey <mh@glandium.org> to control@bugs.debian.org. (Mon, 28 Nov 2011 11:42:13 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Carsten Wolff <carsten@wolffcarsten.de>:
Bug#580308; Package distcc-pump. (Mon, 16 Jan 2012 06:12:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Martin Pool <mbp@sourcefrog.net>:
Extra info received and forwarded to list. Copy sent to Carsten Wolff <carsten@wolffcarsten.de>. (Mon, 16 Jan 2012 06:12:03 GMT) Full text and rfc822 format available.

Message #17 received at 580308@bugs.debian.org (full text, mbox):

From: Martin Pool <mbp@sourcefrog.net>
To: 580308@bugs.debian.org
Subject: patch
Date: Mon, 16 Jan 2012 17:09:14 +1100
There is a patch for this in Ubuntu that seems like it could be
adapted to Debian.

https://launchpadlibrarian.net/69913906/511585.debdiff
https://bugs.launchpad.net/distcc/+bug/511585

-- 
Martin




Information forwarded to debian-bugs-dist@lists.debian.org, Carsten Wolff <carsten@wolffcarsten.de>:
Bug#580308; Package distcc-pump. (Sun, 11 Mar 2012 00:27:06 GMT) Full text and rfc822 format available.

Acknowledgement sent to Daniel Hartwig <mandyke@gmail.com>:
Extra info received and forwarded to list. Copy sent to Carsten Wolff <carsten@wolffcarsten.de>. (Sun, 11 Mar 2012 00:27:06 GMT) Full text and rfc822 format available.

Message #22 received at 580308@bugs.debian.org (full text, mbox):

From: Daniel Hartwig <mandyke@gmail.com>
To: 580308@bugs.debian.org
Subject: update: distcc-pump: hardcoded python version in paths
Date: Sun, 11 Mar 2012 08:22:27 +0800
Effectively the situation involves these factors:

- distcc-pump ships python modules (.py) and extensions (.so)
- the extensions are only compiled for one python version
- installed using distutils
- distcc-pump is a bash script which calls the modules directly
('python /path/to/include_server.py')
- upstream includes a kludge that uses PYTHONPATH to set the location
of the extension (.so)

These factors combine to cause the repeated breakage and difficulties
with this package.

The previous attempts to fix this (both Debian and Ubuntu) is merely
to update the PYTHONPATH kludge for whatever path is *presumed* the
extensions will end up.  This of course breaks as the supported and
default python versions change.

The solution, IMO:

- extension is compiled for all supported python versions OR load with
'python2.N' instead of 'python'
- distutils amended to use --install-format=deb (may not be required)
- remove PYTHONPATH kludge
- bash script should call, e.g., 'python -m
include_server.include_server -c Main()'
- magic (?)

Due to scheduling today I hope to have a patch for this late this
evening.  The issue has already proved quite involved (my hopes of a
one-line fix were smashed.. several times !)

Otherwise, I guess that 'python /path/to/include_server.py' suggests
that these modules are considered private and should really be
installed to /usr/{share,lib}/distcc-pump/include_server.py, etc. and
called directly as '/usr/share/distcc-pump/include_server.py'
(requires fix to #!, which is hard-coded python2.4)

There is also a new upstream release since late 2011.




Information forwarded to debian-bugs-dist@lists.debian.org, Carsten Wolff <carsten@wolffcarsten.de>:
Bug#580308; Package distcc-pump. (Mon, 12 Mar 2012 10:45:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Daniel Hartwig <mandyke@gmail.com>:
Extra info received and forwarded to list. Copy sent to Carsten Wolff <carsten@wolffcarsten.de>. (Mon, 12 Mar 2012 10:45:07 GMT) Full text and rfc822 format available.

Message #27 received at 580308@bugs.debian.org (full text, mbox):

From: Daniel Hartwig <mandyke@gmail.com>
To: 580308@bugs.debian.org
Subject: [PATCH] move python modules to private path
Date: Mon, 12 Mar 2012 18:43:50 +0800
[Message part 1 (text/plain, inline)]
tags 580308 + patch
thanks

The attached patch fixes this issue by moving python modules to a private path.

The modules are for the distcc-pump include server.  This includes a
compiled extension (.so).  To keep things simple all the modules are
installed to /usr/lib/distcc-pump.

Rational for the private path:
  distcc-pump provides no way to run or connect to anything
  other than the upstream supplied include_server.  It is
  not practical for a user to extend or implement their own
  include server, making the include_server package only
  of use to distcc-pump.

A prepared NMU is available on mentors.d.o. [1]  Please note that this update:
  - intends only to be a minimal fix for #580308;
  - only changes files under ./debian;
  - persists previous changes to files not under ./debian;
  - does not attempt to address any of the pre-existing lintian warnings;

That is, all of the issues pointed out by lintian and mentors are pre-existing.

If the original maintainer is unresponsive I am willing to take on
this package and clean up the other packaging issues also.


[1] http://mentors.debian.net/package/distcc

  * Move distcc-pump python modules to private path (/usr/lib/distcc-pump)
    - 04_fix_pumps_include_server_path.dpatch: update for private path
      removes hardcoded python version from path.  Closes: #580308
    - debian/rules: ensure PYTHON points to the default python version.

[2] Sample session using updated distcc-pump:

dth@europa:~/src/aptitude/build-curses/src$ distccd --daemon --allow
127.0.1.1/24
dth@europa:~/src/aptitude/build-curses/src$ export
DISTCC_POTENTIAL_HOSTS="127.0.1.1"
dth@europa:~/src/aptitude/build-curses/src$ distcc-pump make pkg_item.o
__________Using distcc-pump from /usr/bin
__________Found 1 available distcc servers
g++ -DLOCALEDIR=\"/usr/local/share/locale\" -DHAVE_CONFIG_H -I.
-I../../src -I.. -I.. -I../../src -I../.. -I../../src  -I/usr/include
-DHELPDIR=\"/usr/local/share/aptitude\"
-DPKGDATADIR=\"/usr/local/share/aptitude\"  -g -O0
-I/usr/include/sigc++-2.0 -I/usr/lib/sigc++-2.0/include
-I/usr/lib/cwidget -I/usr/include/sigc++-2.0
-I/usr/lib/sigc++-2.0/include   -I/usr/include/tagcoll-2.0.13
-D_REENTRANT -fno-strict-aliasing -Wall -Werror -MT pkg_item.o -MD -MP
-MF .deps/pkg_item.Tpo -c -o pkg_item.o ../../src/pkg_item.cc
mv -f .deps/pkg_item.Tpo .deps/pkg_item.Po
__________Shutting down distcc-pump include server
dth@europa:~/src/aptitude/build-curses/src$ echo $?
0
[move_python_modules_to_private_path.patch (application/octet-stream, attachment)]

Added tag(s) patch. Request was from Daniel Hartwig <mandyke@gmail.com> to control@bugs.debian.org. (Mon, 12 Mar 2012 10:45:18 GMT) Full text and rfc822 format available.

Information stored :
Bug#580308; Package distcc-pump. (Mon, 12 Mar 2012 14:51:12 GMT) Full text and rfc822 format available.

Acknowledgement sent to Daniel Hartwig <mandyke@gmail.com>:
Extra info received and filed, but not forwarded. (Mon, 12 Mar 2012 14:51:12 GMT) Full text and rfc822 format available.

Message #34 received at 580308-quiet@bugs.debian.org (full text, mbox):

From: Daniel Hartwig <mandyke@gmail.com>
To: 580308-quiet@bugs.debian.org, 638258@bugs.debian.org
Subject: NMU on mentors
Date: Mon, 12 Mar 2012 22:46:34 +0800
NMU on mentors.d.n has been updated to include the fix for #638258 also.

http://mentors.debian.net/package/distcc

  * Move distcc-pump python modules to private path (/usr/lib/distcc-pump)
    - 04_fix_pumps_include_server_path.dpatch: update for private path,
      removes hardcoded python version from path.  Closes: #580308
    - debian/rules: ensure PYTHON points to the default python version.
  * Fix FTBFS on hurd-i386 caused by reliance on PATH_MAX.
    Thanks to Jérémie Koenig for the patch.  Closes: #638258




Reply sent to Daniel Hartwig <mandyke@gmail.com>:
You have taken responsibility. (Tue, 13 Mar 2012 02:51:03 GMT) Full text and rfc822 format available.

Notification sent to Michael Casadevall <mcasadevall@debian.org>:
Bug acknowledged by developer. (Tue, 13 Mar 2012 02:51:03 GMT) Full text and rfc822 format available.

Message #39 received at 580308-close@bugs.debian.org (full text, mbox):

From: Daniel Hartwig <mandyke@gmail.com>
To: 580308-close@bugs.debian.org
Subject: Bug#580308: fixed in distcc 3.1-4.2
Date: Tue, 13 Mar 2012 02:48:06 +0000
Source: distcc
Source-Version: 3.1-4.2

We believe that the bug you reported is fixed in the latest version of
distcc, which is due to be installed in the Debian FTP archive:

distcc-pump_3.1-4.2_amd64.deb
  to main/d/distcc/distcc-pump_3.1-4.2_amd64.deb
distcc_3.1-4.2.diff.gz
  to main/d/distcc/distcc_3.1-4.2.diff.gz
distcc_3.1-4.2.dsc
  to main/d/distcc/distcc_3.1-4.2.dsc
distcc_3.1-4.2_amd64.deb
  to main/d/distcc/distcc_3.1-4.2_amd64.deb
distccmon-gnome_3.1-4.2_amd64.deb
  to main/d/distcc/distccmon-gnome_3.1-4.2_amd64.deb



A summary of the changes between this version and the previous one is
attached.

Thank you for reporting the bug, which will now be closed.  If you
have further comments please address them to 580308@bugs.debian.org,
and the maintainer will reopen the bug report if appropriate.

Debian distribution maintenance software
pp.
Daniel Hartwig <mandyke@gmail.com> (supplier of updated distcc package)

(This message was generated automatically at their request; if you
believe that there is a problem with it please contact the archive
administrators by mailing ftpmaster@debian.org)


-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA512

Format: 1.8
Date: Mon, 12 Mar 2012 22:25:08 +0800
Source: distcc
Binary: distcc distccmon-gnome distcc-pump
Architecture: source amd64
Version: 3.1-4.2
Distribution: unstable
Urgency: low
Maintainer: Carsten Wolff <carsten@wolffcarsten.de>
Changed-By: Daniel Hartwig <mandyke@gmail.com>
Description: 
 distcc     - Simple distributed compiler client and server
 distcc-pump - pump mode for distcc a distributed compiler client and server
 distccmon-gnome - GTK+ monitor for distcc a distributed client and server
Closes: 580308 638258
Changes: 
 distcc (3.1-4.2) unstable; urgency=low
 .
   * Non-maintainer upload.
   * Move distcc-pump python modules to private path (/usr/lib/distcc-pump)
     - 04_fix_pumps_include_server_path.dpatch: update for private path,
       removes hardcoded python version from path.  Closes: #580308
     - debian/rules: ensure PYTHON points to the default python version.
   * Fix FTBFS on hurd-i386 caused by reliance on PATH_MAX.
     Thanks to Jérémie Koenig for the patch.  Closes: #638258
Checksums-Sha1: 
 a7a0133eb600171d89a611a44f0f7d0a3b636cc1 1845 distcc_3.1-4.2.dsc
 3ff85221b219fa9950ec9ca377de47eb740bed5d 68167 distcc_3.1-4.2.diff.gz
 9e3217dddfef3170dc448494f8c35577bb0a5138 249530 distcc_3.1-4.2_amd64.deb
 ff01427cc8c65a6d8e879201c4b60bd8218466cd 45016 distccmon-gnome_3.1-4.2_amd64.deb
 ee7e8ab7476b51c92d1f0a482ab616be8610926e 142230 distcc-pump_3.1-4.2_amd64.deb
Checksums-Sha256: 
 e6feeb980adb639d62aac4eed8d0570d251d75f1c7b993b889fc4bb047f06a66 1845 distcc_3.1-4.2.dsc
 332c39e4256393772d4e8ddc584a53c629beeef3e835cbe6c7cc48c8cb29000b 68167 distcc_3.1-4.2.diff.gz
 e43d0a2370fa71d4ef7b3109d139c133c642465cd5e82eaa5c41a12c0da5ae2b 249530 distcc_3.1-4.2_amd64.deb
 2b5d5dc5537be6dd3b271a83f30b0875022bb09bbe31318efa0de59d0dc62a6c 45016 distccmon-gnome_3.1-4.2_amd64.deb
 69f22eb4a649991108a07c2192c1e657a6f638be2e14472bcb59cd98abd9e292 142230 distcc-pump_3.1-4.2_amd64.deb
Files: 
 59e4580641abfb63507d9d3d3bfa1528 1845 devel optional distcc_3.1-4.2.dsc
 27577cd42faa04d6b0c1ea2a13bfe7c9 68167 devel optional distcc_3.1-4.2.diff.gz
 a1574117f5055a46c7ef67ab74abbbfe 249530 devel optional distcc_3.1-4.2_amd64.deb
 01c9a51a718856f719534263523db838 45016 devel optional distccmon-gnome_3.1-4.2_amd64.deb
 0c15cb02619edc10cc108085e4f5f68c 142230 devel optional distcc-pump_3.1-4.2_amd64.deb

-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.4.11 (GNU/Linux)

iQIcBAEBCgAGBQJPXqY2AAoJEDEWul6f+mmj+7gQAJaMIbLSgBCyOukT6WNRXwo5
lsZoU46mNU0kNcdYPCoXcMS2OnD/oc04XYS61fpSWvoAQnqYOC70z0fssc3T+HUJ
qsB8A+0ks3Ls6cf45YY4hbJYul0vExA/zI1r2WEE3LKjxtvd6vjZrC/2krp0/LKL
ztsNlBHj8uA0g7VzjFw7YPg+gVsYFfEKTJh5X1Gd7TPlKWJ8p39KcHfBK++Jmnlp
YQWflxXzXvTyII2KC6ObrHetQFoCLkPknxtIERBngZcNhnqktpOfVAFL2+Xsd+ME
bQrMLBwUIzhBwE/g0gxYCKKc9isSYgGSzonpNNdhmyU2iK6oeQedX0lHvaFLfrGR
X44pGfCedRZJzJWKKX/ALxgHQDJPI1YOtCDVvQ8UVhdEnq/OTF/cCf+IZboxKIkF
KW9Uy1zFKx1SFCtrXd6sHoweWOijQCYb1jPi+huwA+gOXaZqM8utNUrYGOBzRr9R
3ytXOftrPo2TTSMtTc1G7p1FWQlc4DGs54HZxhotrOu0+rxuxhJ6mo1KxfmtuWP+
qfHLvW28zRF2L6ltdIAT/SIBSaJHZryqPfpjgyEvWkNMyvUE6/DwmKovxNfy22d0
frlxHJzdF4Og4mtXLPMivxHTspcvMdq9834ShqLDceWT3abcHCOdHiZrlVlB/wRi
Lv+Mn2MDALZJ5CxWjzxD
=E/z8
-----END PGP SIGNATURE-----





Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Sun, 02 Jun 2013 07:32:14 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Mon Apr 21 12:14:19 2014; Machine Name: beach.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.